# Analysis-of-Short-RNAs
Wrapper program for [Blumenfeld's work on 22G and 26G RNAs in C. elegans](http://www.clfs.umd.edu/cbmg/joselab/myPdfs/BlumenfeldALJoseAM_RNA_2016.pdf)
(c) Jose Lab, University of Maryland, October 17 2016. Written by Rex Ledesma.

1. Download [Blumenfeld’s Scripts](http://www.clfs.umd.edu/cbmg/joselab/resources/blumenfeld_scripts.zip)

2. Import galaxy workflows in `Galaxy_Workflows` and files in `static_data` into galaxy account

3. Edit `download_datasets_cmd.py`. In lines 60 and 61, change:
	- `galaxy_url` to http://GALAXY.INSTANCE/
	- `api_key` to `GALAXY_API_KEY`, found in Galaxy instance
	- _OPTIONAL_: `output_dir` to other directory. Default directory is the current working directory

4. Edit `WORKFLOW_TEMPLATE.json`. Need to change:
	- `galaxy_url` to http://GALAXY.INSTANCE/
	- `api_key` to `GALAXY_USER_API_KEY`, found in Galaxy instance
	- _OPTIONAL_: `output_dir` to other directory. Default directory is the current working directory
	- all the workflow API IDs in `.json` file to the user's associated workflows API IDs (found by editing the workflow, and copying the ID in the browser address bar within Galaxy)
		1. search for workflow step number, (17 steps in total i.e: `1.`, `2.`, … `11a.`, `11b.`, … , `16.`)
			* for each workflow step, replace all occurrences of the id for each workflow within the JSON file with the new workflow ID, found in the galaxy url of the workflow
			* delete extraneous label to the right of the ID field
				- FYI: 48 IDs to change, 48 labels to delete
			* change static data API IDs (after importing them to your Galaxy account)

5. Execute `python run_multiple_workflows.py`, and follow instructions. Optional notation style:
	- Name of dataset: `SRX_NUMBER_OF_EXPERIMENT`
	- Name of run: `YOUR_NAME_AND_CURRENT_DATE`

6. Check Galaxy if workflows are running.
	- Check step 6 in workflow 1: ensure that not all reads are discarded; otherwise, inputted adapter sequence is probably wrong)
	- Check if any errors appear. Here are a few that you might encounter:
		1. _Text file busy._
			* Run the step again, and click _Resume dependencies from this job_
		2. _Failed runtime validation of ... (An invalid option was selected, please verify)_
			* Too much filtering occurred in the dataset, resulting in an empty dataset. Delete the failed, queued, and paused steps in the workflow to let it proceed

7. If terminal was closed, reattach the tmux session.
	- `tmux ls` to see all names of all tmux sessions
	- `tmux attach -t [session name]` to reattach tmux session
	- check for notification of completion of workflow

8. Check if raw data and graphs have been saved to specified directory.
